﻿Imports Microsoft.Practices.Prism.Events
Imports Microsoft.Practices.Prism.Modularity
Imports Microsoft.Practices.Prism.Regions
Imports Microsoft.Practices.Unity
Imports MsdnDemo.Infrastructure.Portable.Base
Imports MsdnDemo.Infrastructure.Portable.Events
Imports MsdnDemo.Infrastructure.Portable.Logger
Imports MsdnDemo.Infrastructure.Portable.Types
Imports MsdnDemo.Phone.Events

Namespace MsdnDemo.Base
    Public Class PresentationModuleBase
        Inherits ModuleBase
        Implements IModule
        <Dependency()>
        Public Overrides Property Logger() As ILogger

        <Dependency()>
        Public Property Container() As IUnityContainer

        <Dependency()>
        Public Property RegionManager() As IRegionManager

        <Dependency()>
        Public Property EventAggregator() As IEventAggregator

        <Dependency()>
        Public Property RegionViewRegistry() As IRegionViewRegistry


        Protected Sub RaiseViewEvent(ByVal moduleName As String, ByVal viewName As String, ByVal processType As ProcessType)
            EventAggregator.GetEvent(Of ViewEvent)().Publish(New ViewEventArgs With {.ModuleName = moduleName, .ProcessType = ProcessType.ActivateView, .ViewNameToActivate = viewName})
        End Sub

        ''' <summary>
        ''' Notify the ApplicationController that the login was successful so that it can
        ''' load (on demand) the password manager module (as configured in the Bootstrapper)
        ''' Once modules are loaded they will not be loaded again so it is harmless on
        ''' successive calls.
        ''' </summary>
        ''' <param name="moduleName">Name of the module.</param>
        ''' <param name="viewName">Name of the view.</param>
        Protected Sub RaiseModuleEvent(ByVal moduleName As String, ByVal viewName As String, ByVal eventType As ModuleEventType)
            EventAggregator.GetEvent(Of ModuleEvent)().Publish(New ModuleEventArgs With {.ModuleName = moduleName, .EventType = eventType, .PayLoad = viewName}) ' The view to load on click
        End Sub

        Private Shadows Sub Initialize() Implements IModule.Initialize
            MyBase.Initialize()
        End Sub
    End Class
End Namespace