﻿Imports Microsoft.Practices.Prism.Commands
Imports Microsoft.Practices.Unity
Imports MsdnDemo.Infrastructure.Portable.Logger
Imports MsdnDemo.Infrastructure.Portable.MvpVmBase

Namespace MsdnDemo.Base
    Public Class PresentationViewModelBase
        Inherits MvpVmViewModel
        <Dependency()>
        Public Property Logger() As ILogger

        Public Property ButtonCommand() As DelegateCommand(Of Object)

        Private _isAdmin As Boolean
        Public Property IsAdmin() As Boolean
            Get
                Return _isAdmin
            End Get
            Set(ByVal value As Boolean)
                _isAdmin = value
                OnPropertyChanged("IsAdmin")
            End Set
        End Property

        Private _isGuest As Boolean
        Public Property IsGuest() As Boolean
            Get
                ' Admin has all roles but we don't 
                ' want it seen as a guest
                Return _isGuest AndAlso Not IsAdmin
            End Get
            Set(ByVal value As Boolean)
                _isGuest = value
                OnPropertyChanged("IsGuest")
            End Set
        End Property
    End Class
End Namespace