﻿Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Documents
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Shapes
Imports Microsoft.Phone.Controls
Imports MsdnDemo.Infrastructure.Portable.Interfaces
Imports Microsoft.Practices.ServiceLocation
Imports Microsoft.Practices.Prism.UnityExtensions
Imports Microsoft.Practices.Prism.Regions
Imports Microsoft.Practices.Unity
Imports MsdnDemo.Prism

Namespace MsdnDemo
    Partial Public Class MainPage
        Inherits PhoneApplicationPage
        Implements IShell
        ' Constructor
        Public Sub New()
            ' we'll require a unity container so that we can set up our
            ' service locator
            Dim container = New UnityContainer


            ' Typically this will be available because Prism is started in
            ' the App. For the Phone we start Prism in the MainShell so
            ' we have to ensure our Shell has a service locator and 
            ' RegionAdapterMappings registration PRIOR to initializeComponent
            ' otherwise the XAML bindings for RegionManager will crash
            container.RegisterType(Of IServiceLocator, UnityServiceLocatorAdapter)(New ContainerControlledLifetimeManager())

            container.RegisterType(GetType(RegionAdapterMappings), GetType(RegionAdapterMappings), New ContainerControlledLifetimeManager())

            ' Set the service locator (singleton)
            ServiceLocator.SetLocatorProvider(container.Resolve(Of IServiceLocator)())

            InitializeComponent()

            ' With RegionManager wired-up we can now
            ' execute our bootstrapper passing in a reference
            ' to this (shell) so that it can pass it into 
            ' Prism.  Typically Prism creates the shell and 
            ' passes it to the framework but the Phone doesn't
            ' provide us a hook to do so.
            Dim bootstrapper = New GwnBootstrapper(container)

            bootstrapper.Run(Me)
        End Sub

        Private Shadows Property DataContext() As Object Implements IView.DataContext
            Get
                Return MyBase.DataContext
            End Get
            Set(ByVal value As Object)
                MyBase.DataContext = value
            End Set
        End Property

        Private Shadows Function FindName(ByVal ctrlName As String) As Object Implements IView.FindName
            Return FindName(ctrlName)
        End Function
    End Class
End Namespace