﻿Imports Microsoft.Practices.Unity
Imports MsdnDemo.Base
Imports MsdnDemo.Infrastructure.Portable.Constants
Imports MsdnDemo.Infrastructure.Portable.Types
Imports MsdnDemo.MvpVmPresenters

Namespace MsdnDemo.Modules
    Public Class MainModule
        Inherits PresentationModuleBase
        Protected Overrides Sub RegisterViews()
            MyBase.RegisterViews()

            ' Instantiate the presenter, which in turn will instantiate
            ' (resolve) the View and ViewModel
            Dim presenter = Container.Resolve(Of MainPresenter)()

            ' Load this presenters view into the MainRegion
            RegionViewRegistry.RegisterViewWithRegion(MvpVm.MainRegion, Function() presenter.View)

            ' Activate the presenters view after module is loaded
            RaiseViewEvent(MvpVm.MainModule, presenter.View.GetType().Name, ProcessType.ActivateView)
        End Sub
    End Class
End Namespace