﻿Imports Microsoft.Practices.Unity
Imports MsdnDemo.Base
Imports MsdnDemo.Infrastructure.Portable.Constants
Imports MsdnDemo.Infrastructure.Portable.Entities
Imports MsdnDemo.Infrastructure.Portable.Interfaces
Imports MsdnDemo.LayerBusinessLogic
Imports MsdnDemo.LayerBusinessLogic.Interfaces
Imports MsdnDemo.LayerDataAccess
Imports MsdnDemo.MvpVmPresenters

Namespace MsdnDemo.Modules
    Public Class SecurityModule
        Inherits PresentationModuleBase
        Protected Overrides Sub RegisterTypes()
            MyBase.RegisterTypes()

            ' Roles
            ' User
            ' User Role
            ' Register the security view model as a singleton so that
            ' we can get it's information (isauthenticated, username, etc)
            ' from other modules/processes
            Container.RegisterType(Of IRolesBll, RoleBll)().RegisterType(Of IDal(Of RoleEntity), RolesDal)().RegisterType(Of IUserBll, UserBll)(New ContainerControlledLifetimeManager()).RegisterType(Of IDal(Of UserEntity), UserDal)().RegisterType(Of IUserRoleBll, UserRoleBll)().RegisterType(Of IDal(Of UserRoleEntity), UserRoleDal)().RegisterType(Of ISecurityViewModel, SecurityEntity)(New ContainerControlledLifetimeManager()) ' We'll let Sqlite handler our Bll/Dal
        End Sub

        Protected Overrides Sub RegisterViews()
            MyBase.RegisterViews() ' Log that we are here

            ' Initialize system roles in userBll singleton
            Container.Resolve(Of IUserBll)().Initialize()

            ' Instantiate the presenter, which in turn will instantiate
            ' (resolve) the View, ViewModel, and dependencies
            Dim presenter = Container.Resolve(Of SecurityPresenter)()

            ' Place the SecurityView in the MainRegion 
            RegionViewRegistry.RegisterViewWithRegion(MvpVm.MainRegion, Function() presenter.View)
        End Sub

    End Class
End Namespace