﻿Imports System.Windows.Controls
Imports Microsoft.Practices.Unity
Imports MsdnDemo.Base
Imports MsdnDemo.Infrastructure.Portable.Constants
Imports MsdnDemo.Infrastructure.Portable.Events
Imports MsInterfaces = MsdnDemo.Infrastructure.Portable.Interfaces
Imports MsdnDemo.Infrastructure.Portable.Types
Imports MsdnDemo.MvpVmViewModels
Imports MsdnDemo.MvpVmViews

Namespace MsdnDemo.MvpVmPresenters
    Public Class GuestPresenter
        Inherits PresentationPresenterBase(Of GuestView, MainViewModel)
        <Dependency()>
        Public Property SecurityViewModel() As MsInterfaces.ISecurityViewModel

        Protected Overrides Sub Initialize()
            MyBase.Initialize() ' Logs initialize

            ' Add the view model to the view model holder
            View.ViewModelHolder.Items.Add(ViewModel)
        End Sub

        Public Overrides Sub ViewActivated(ByVal e As ViewEventArgs)
            MyBase.ViewActivated(e)

            ViewModel.Message = Nothing ' reset

            ' Assign role flags as applicable
            ViewModel.IsGuest = SecurityViewModel.IsInRole("Guest")
        End Sub

        Protected Overrides Sub ExecuteButtonCommandHandler(ByVal sender As Object, ByVal e As DelegateCommandEventArgs)
            MyBase.ExecuteButtonCommandHandler(sender, e) ' Log we are here

            Select Case (CType(e.Sender, Button)).Name
                Case "btnLogin"
                    ' Activate the login screen (SecurityView) in the SecurityModule
                    RaiseViewEvent(MvpVm.SecurityModule, MvpVm.SecurityView, ProcessType.ActivateView)

                Case "btnMainView"
                    ' Activate the login screen (SecurityView) in the SecurityModule
                    RaiseModuleEvent(MvpVm.MainModule, MvpVm.MainView, ModuleEventType.Login)
            End Select
        End Sub

        Public Overrides Sub MessageEventHandler(ByVal e As MessageEventArgs)
            ViewModel.Message = e.Message
        End Sub
    End Class
End Namespace