﻿Imports System
Imports MsdnDemo.Infrastructure.Portable.Logger

Namespace MsdnDemo.Infrastructure.Portable.Base
    Public Class ModuleBase
        Public Overridable Property Logger() As ILogger

        ''' <summary>
        ''' Called by Prism catalog manager.  Provides hook 
        ''' to register types/views and initialize the view model
        ''' </summary>
        Public Overridable Sub Initialize()
            Try
                ' Provide hooks for registrations
                RegisterTypes()
                RegisterViews()

                InitializeModule()
            Catch ex As Exception
                Logger.Log("ERROR in [{0}] {1}{2}", Me.GetType().Name, ex.Message, ex.StackTrace)
            End Try
        End Sub

        Protected Overridable Sub RegisterTypes()
            Logger.Log("{0}.RegisterTypes", Me.GetType())
        End Sub

        Protected Overridable Sub RegisterViews()
            Logger.Log("{0}.RegisterViews", Me.GetType())
        End Sub

        Protected Overridable Sub InitializeModule()
            Logger.Log("{0}.InitializeModules()", Me.GetType())
        End Sub
    End Class
End Namespace