﻿Imports System.Linq
Imports System.Collections.Generic
Imports MsdnDemo.Infrastructure.Portable.Interfaces

Namespace MsdnDemo.Infrastructure.Portable.Entities
    Public Class SecurityEntity
        Implements ISecurityViewModel
        Private _login As String
        Public Property Id() As Integer Implements ISecurityViewModel.Id
        Public Property IsAuthenticated() As Boolean Implements ISecurityViewModel.IsAuthenticated
        Public Property Roles() As IEnumerable(Of String) Implements ISecurityViewModel.Roles

        Public Property Login() As String Implements ISecurityViewModel.Login
            Get
                Return _login
            End Get
            Set(ByVal value As String)
                _login = value
                Id = 0
                IsAuthenticated = False
                Roles = New List(Of String)()
            End Set
        End Property

        Public Function IsInRole(ByVal roleName As String) As Boolean Implements ISecurityViewModel.IsInRole
            If Roles Is Nothing Then
                Return False
            End If

            Return Roles.FirstOrDefault(Function(r) r = roleName) IsNot Nothing
        End Function

        Public Function IsInRole(ByVal roles() As String) As Boolean Implements ISecurityViewModel.IsInRole
            Return roles.Any(Function(role) IsInRole(role))
        End Function
    End Class
End Namespace