﻿Imports System
Imports MsdnDemo.Infrastructure.Portable.Types

Namespace MsdnDemo.Infrastructure.Portable.Events
    ''' <summary>
    ''' View Event arguments
    ''' </summary>
    Public Class ViewEventArgs
        Inherits EventArgs
        ''' <summary>
        ''' Gets or sets the type of the process.
        ''' </summary>
        ''' <value>The type of the process.</value>
        Public Property ProcessType() As ProcessType

        ''' <summary>
        ''' Gets or sets the view.
        ''' </summary>
        ''' <value>The view.</value>
        Public Property View() As Object

        ''' <summary>
        ''' Gets or sets the name of the module.
        ''' </summary>
        ''' <value>The name of the module.</value>
        Public Property ModuleName() As String

        ''' <summary>
        ''' Gets or sets the view name to activate.
        ''' </summary>
        ''' <value>The view name to activate.</value>
        Public Property ViewNameToActivate() As String

        ''' <summary>
        ''' Gets or sets the view to activate.
        ''' </summary>
        ''' <value>The view to activate.</value>
        Public Property ViewTypeToActivate() As Type

        ''' <summary>
        ''' Gets the view.
        ''' </summary>
        ''' <typeparam name="T"></typeparam>
        ''' <returns></returns>
        Public Function GetView(Of T)() As T
            If TypeOf View Is T Then
                Return CType(View, T)
            End If
            Return Nothing
        End Function

        ''' <summary>
        ''' Returns a <see cref="System.String"/> that represents this instance.
        ''' </summary>
        ''' <returns>
        ''' A <see cref="System.String"/> that represents this instance.
        ''' </returns>
        Public Overrides Function ToString() As String
            Return String.Format("ProcessType: {0}  View:{1}   ViewTypeToActivate:{2}", ProcessType, View, ViewTypeToActivate)
        End Function

    End Class
End Namespace