﻿Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Linq
Imports System.Text

Namespace MsdnDemo.Infrastructure.Portable.MvpVmBase
    Public Class MvpVmViewModel
        Implements IMvpVmViewModel, INotifyPropertyChanged
        ' View models can be reused so we may need to know
        ' this id when handling events
        Public Id As Guid = Guid.NewGuid()

        Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged

        Private Sub InvokePropertyChanged(ByVal e As PropertyChangedEventArgs)
            Dim handler = PropertyChangedEvent
            If handler IsNot Nothing Then
                handler(Me, e)
            End If
        End Sub

        Protected Sub OnPropertyChanged(ByVal propertyName As String)
            InvokePropertyChanged(New PropertyChangedEventArgs(propertyName))
        End Sub

        Public Property Presenter() As IMvpVmPresenter Implements IMvpVmViewModel.Presenter


    End Class
End Namespace