﻿#Const SqliteTest = True
Imports System.Linq
Imports System.Collections.Generic
Imports Microsoft.Practices.Unity
Imports Microsoft.VisualStudio.TestTools.UnitTesting
Imports MsdnDemo.Infrastructure.Portable.Constants
Imports MsdnDemo.Infrastructure.Portable.Entities
Imports MsdnDemo.Infrastructure.Portable.Events
Imports MsdnDemo.Infrastructure.Portable.Interfaces
Imports MsdnDemo.LayerBusinessLogic
Imports MsdnDemo.LayerBusinessLogic.Interfaces
Imports MsdnDemo.LayerDataAccess
Imports MsdnDemo.Mvc3.Tests.Base
Imports MsdnDemo.Mvc3.Tests.Mocks

Namespace MsdnDemo.Mvc3.Tests.Layers
    <TestClass()>
    Public Class RolesFixture
        Inherits FixtureBase
        Private _testBll As IBll

        <TestInitialize()>
        Public Sub InitializeTest()
            ' Registers default values (normally supplied by Prism)
            Initialize()

#If SqliteTest Then
            ' Roles
            ' UserInfo
            ' User Role
            ' Mock
            Container.RegisterType(Of IRolesBll, RoleBll)().RegisterType(Of IDal(Of RoleEntity), RolesDal)().RegisterType(Of IUserBll, UserBll)().RegisterType(Of IDal(Of UserEntity), UserDal)().RegisterType(Of IUserRoleBll, UserRoleBll)().RegisterType(Of IDal(Of UserRoleEntity), UserRoleDal)().RegisterType(Of IMockBll, MockBll)().RegisterType(Of IDal(Of MockEntity), MockDal)()
#Else
				' TODO: Sql server registrations go here....
#End If

            _testBll = Container.Resolve(Of IRolesBll)()
            _testBll.Initialize()
        End Sub

        <TestMethod()>
        Public Sub EmptyRolesTableCreatesDefaults()
            Dim resultArgs = New DalEventArgs

            Dim status = _testBll.List(resultArgs)
            Assert.AreEqual(StatusCode.Success, status)

            Dim list = New List(Of RoleEntity)(resultArgs.GetResults(Of IEnumerable(Of RoleEntity))())

            Assert.IsTrue(list.Count > 0, "Default roles should have been created")
            Assert.IsNotNull(list.FirstOrDefault(Function(r) r.Role = "Admin"))
            Assert.IsNotNull(list.FirstOrDefault(Function(r) r.Role = "User"))
            Assert.IsNotNull(list.FirstOrDefault(Function(r) r.Role = "Guest"))

            ' Cleanup
            _testBll.DropTable()
        End Sub

    End Class
End Namespace